image:
  name: hashicorp/terraform:light
  entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
    - 'AWS_SECRET_ACCESS_KEY=${AWS_SECRET_ACCESS_KEY}' 
    - 'AWS_ACCESS_KEY_ID=${AWS_ACCESS_KEY_ID}' 

variables:
  PLAN: plan.tfplan

cache:
  paths:
    - .terraform

before_script:
  - terraform --version
  - terraform init

stages:
  - validate
  - build-backend
  - plan
  - apply
  - destroy

lint:
  stage: validate
  script: |
      set +o pipefail
      echo "running tf format" 
      fmt_diff=$(git diff-tree --no-commit-id --name-only -r ${CI_COMMIT_SHA} | grep '\.tf$' | xargs -I{} bash -c 'cd "$(dirname {})" && terraform fmt -write=false "$(basename {})"' | sed '/^\s*$/d')
      if test -n "$fmt_diff"; then
       echo "******* Terraform formatting error:"
       echo ""
       echo $fmt_diff
       exit 1
      fi


validate:
  stage: validate
  script:
    - terraform validate


build-backend:
  stage: build-backend
  script:
    - cd remote state
    - terraform plan -out=$PLAN
    - terraform apply -input=false $PLAN
  artifacts:
    name: plan
    paths:
      - $PLAN
  when: manual
  only:
    - master

plan-branches:
  stage: plan
  script:
    - terraform plan 
  only:
    - branches

plan:
  stage: plan
  script:
    - terraform plan -out=$PLAN
  artifacts:
    name: plan
    paths:
      - $PLAN
  only:
    - master

apply:
  stage: apply
  script:
    - terraform apply -input=false $PLAN
  dependencies:
    - plan
  when: manual
  only:
    - master

destroy:
  stage: destroy
  script:
    - terraform destroy -auto-approve 
  dependencies:
    - plan
  when: manual
  only:
    - master